package de.fhdw.wtf.tooling.editor;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.rules.FastPartitioner;
import org.eclipse.ui.editors.text.FileDocumentProvider;

public class WTFDocumentProvider extends FileDocumentProvider {
	
	@Override
	protected IDocument createDocument(final Object element) throws CoreException {
		final IDocument document = super.createDocument(element);
		// TODO write document partitioner for WTF
		if (document != null) {
			final IDocumentPartitioner partitioner =
					new FastPartitioner(WTFPartitionScanner.getInstance(),
							new String[] { WTFPartitionScanner.WTF_COMMENT_PARTITION, });
			partitioner.connect(document);
			document.setDocumentPartitioner(partitioner);
		}
		
		return document;
	}
}
